# -*- coding: utf-8 -*-
from django.contrib.auth.forms import *
from django.shortcuts import render_to_response as render
from django.template import RequestContext, loader, Context

from django_authopenid.forms import *
from youloc.youlocapp.models import LatestLocation

def reverse_geonames_lookup(latitude, longitude): # TODO: Put to a helper-function-file
    try:
        from BeautifulSoup import BeautifulStoneSoup
    except:
        return ''
    from urllib2 import urlopen
    geonames = urlopen('http://ws.geonames.org/findNearby?lat='+str(latitude)+'&lng='+str(longitude))
    soup = BeautifulStoneSoup(geonames.read())
    geoname = soup.findAll('name')[0].string
    return str(geoname+" ("+soup.countryname.string+")")
    
def home(request):
    form1 = OpenidSigninForm()
    form2 = AuthenticationForm()
    try:
        latestlocation = LatestLocation.objects.get(user=request.user)
        geoname = reverse_geonames_lookup(latestlocation.latitude, latestlocation.longitude)
    except:
        latestlocation = False
        geoname = ''
    return render("home.html", {
        'form1': form1,
        'form2': form2,
        'location': latestlocation,
        'geoname': geoname
    }, context_instance=RequestContext(request))