import urllib, hashlib
from django import template
from datetime import datetime

register = template.Library()


def location_icon(updatetime, limit_minutes):
    limit = int(limit_minutes * 60)
    if ( ( int(datetime.now().strftime("%s")) - int(updatetime.strftime("%s")) ) < limit ):
        return "onlineStyle"
    else:
        return "offlineStyle"

register.filter('location_icon', location_icon)


@register.inclusion_tag('templatetags/gravatar.html')
def show_gravatar(email, size=48):
    default = "http://youloc.net/media/img/vihrea.png"

    url = "http://www.gravatar.com/avatar.php?"
    url += urllib.urlencode({
        'gravatar_id': hashlib.md5(email).hexdigest(), 
        'default': default, 
        'size': str(size)
    })

    return {'gravatar': {'url': url, 'size': size}}

